import Combine
import SwiftUI

final class VM: ObservableObject {
  @Published var text = "a:"
  
  var subscriptions = [AnyCancellable]()

  init() {
      Bus.send(
        MeetupId.K.meetupIdTextUI.rawValue,
        $text
            // Исключаем конфликты от UI и App путём игнорирования спама.
            .debounce(for: .seconds(0.3), scheduler: DispatchQueue.main)
            // Нужны лишь значения от UI.
            .filter { $0.hasPrefix("u:") }
            // Убираем источник.
            .map { String($0.dropFirst(2)) }
            .eraseToAnyPublisher(),
        sub: &subscriptions
      )

      Bus.receive(
        [MeetupId.K.meetupIdTextApp.rawValue],
        { [weak self] (_, v: String) in self?.text = "a:\(v)" },
        opt: [.async],
        sub: &subscriptions
      )
  }
}
